/*
 *		@file			ISubscriber.aidl
 *
 *		@author			M.G.Jeong < myeong.jeong@samsung.com >
 */

package com.sec.android.allshare.iface;

import com.sec.android.allshare.iface.CVMessage;

/*
 *	ISubscriber
 *
 *	AllShare service subscriber interface
 */
interface ISubscriber {

	/*
	 *	Asynchronous request to Service.
	 *
	 *	@param	subscriber		subscriber id
	 *	@param	cvm				context variable message of request 
	 */
	boolean	requestCVAsync(	in String subscriber, in CVMessage cvm );


	/*
	 *	Synchronous request to Service.
	 *
	 *	@param	subscriber		subscriber id
	 *	@param	cvm				context variable message of request 
	 */
	CVMessage	requestCVSync( in String subscriber, in CVMessage cvm );

	/*
	 *	Subscribe to retrieve AllShare event message. 
	 *
	 *	@param	subscriber		subscriber id
	 *	@param	cvm				context variable message of subscription 
	 */
	boolean		subscribeEvent( in String subscriber, in CVMessage cvm );

	/*
	 *	Unsubscribe to retrieve AllShare event message. 
	 *
	 *	@param	subscriber		subscriber id
	 *	@param	cvm				context variable message of unsubscription 
	 */
	void		unsubscribeEvent( in String subscriber, in CVMessage cvm );
	
	/*
	 *	Synchronous request to get service version. 
	 *
	 */
	String		getServiceVersion();	

} /* end of ISubscriber */

/* end of file. */
